/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2024  SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region;

import de.steamwar.bausystem.region.flags.Flag;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

public class FixedFlagStorage implements FlagStorage {

    private Map<Flag<?>, Flag.Value<?>> flagMap = new HashMap<>();

    public static FlagStorage createFromRegion(Region region) {
        FlagStorage flagStorage = new FixedFlagStorage();
        Flag.getFlags().forEach(flag -> {
            if (region.hasFlag(flag).isReadable()) {
                flagStorage.set(flag, flag.getDefaultValue());
            }
        });
        return flagStorage;
    }

    public static FlagStorage createFromFile(File file) {
        throw new IllegalStateException("Not implemented yet");
    }

    @Override
    public <T extends Enum<T> & Flag.Value<T>> boolean set(Flag<T> flag, T value) {
        return flagMap.put(flag, value) != value;
    }

    @Override
    public <T extends Enum<T> & Flag.Value<T>> T get(Flag<T> flag) {
        return (T) flagMap.get(flag);
    }
}
